#!/usr/local/bin/perl

$| = 1;

push(@INC,'/home/wcohen/perl');
require 'altavista-search.pl';

$stem = shift(@ARGV) || 'aha';

chdir("/home/wcohen/datasets/homepage/") || die;
open(Q,"<$stem.train") || die;
@queries = <Q>;
chop(@queries);
close(Q);
print $#queries+1," queries\n";

open(H,"<$stem.heuristics") || die;
@schemata = <H>;
chop(@schemata);
close(H) ;
print $#schemata+1," query schemata\n";

$Options = "-p3";

open(LOG,">queries.log");
for ($i=0; $i<=$#queries; $i++) {
    ($n,$p,$u) = split(/\|/,$queries[$i]);
    print "$n from $p: $u\n","=" x 60,"\n";
    for ($j=0; $j<=$#schemata; $j++) {
	$stem = sprintf("e%02d-q%03d",$j,$i);
	&create_data($schemata[$j],$queries[$i],$stem);
    }
}
close(LOG);

sub create_data
{
    local($schema,$query,$filestem) = @_;
    local($name,$place,$url,$u,$lastname,$thisquery,@thesesurls,@names,$stat);

    return unless $schema;
    ($name,$place,$url) = split(/\|/,$query);

    #check that the url is there
    $stat = &http_get($url,"/tmp/homepage-test.html");
    print LOG "status:  $stat $url\n";
    return unless ($stat==200); 

    #log what's done
    print LOG "created: $filestem : $schema : $name : $place\n";

    #extract last name and convert to lower case
    @names =  split(/\s+/,$name);
    $lastname = pop(@names);
    $lastname =~ tr/A-Z/a-z/;

    #create the query
    $thisquery = $schema;
    $thisquery =~ s/LASTNAME/$lastname/g; 
    $thisquery =~ s/PLACE/$place/g; 
    $thisquery =~ s/NAME/$name/g; 
    print "submitting [",$thisquery,"]\n";

    @theseurls = &submit_query($thisquery,$Options);
    open(F,">queries/$filestem.rank") || die;
    $url = &normalize($url);
    foreach $u (@theseurls) {
	$u = &normalize($u);
	$class = ($u eq $url) ? 'P' : 'N' ;
#	print "$u\t$class\n";
	print F "$u\t$class\n";
    }
    close(F);
}

sub normalize
{
    local($url) = @_;

    $url =~ s#:80##;
    $url =~ s#/(index|home).html?$##;
    $url =~ s#/$##;
    $url;
}
